import { buildUUID } from '../../../utils/uuid';
import { ApiAction, ApiActionPage } from '../../model/baseModel';
import { OperListItem, OperPageParams, OperPageListGetResultModel } from '../model/mesModel';
import { genAction, Api, genActionPage } from '../system';
import { defHttp } from '/@/utils/http/axios';
import { useUserStore } from '../../../store/modules/user';

/*
 * 获取工序分页列表
 */
export const getOperListByPage = async (params: OperPageParams) => {
  let sqlcmd = '';
  if (params?.OPER_CODE != undefined && params?.OPER_CODE != '') {
    sqlcmd += "And OPER_CODE like '%" + params?.OPER_CODE + "%'";
  }
  if (params?.OPER_NAME != undefined && params?.OPER_NAME != '') {
    sqlcmd += "And OPER_NAME like '%" + params?.OPER_NAME + "%'";
  }
  const rParams = genActionPage('MES_OPERATION', sqlcmd, params.page, params.pageSize);
  return getOperListByPageAsync(rParams);
};
async function getOperListByPageAsync(_params: ApiActionPage) {
  //   const data = await defHttp.post<ApiActionPage>(
  //     { url: Api.EntityPageList, params },
  //     {
  //       isTransformResponse: false,
  //     },
  //   );
  const data: OperListItem[] = [
    {
      ID: '1',
      OPER_CODE: 'ASSY',
      OPER_NAME: '组装上料',
      OPER_TYPE: '1',
      FACTORY: '鸿鹄WMS',
      IS_FPY: 'N',
      IS_REFLOW: 'N',
      CREATE_USER: useUserStore().getUserInfo.userId,
      UPDATE_USER: useUserStore().getUserInfo.userId,
      UPDATE_TIME: '2023-02-06',
      CREATE_TIME: '2023-02-06',
      OPER_ACTION: '1',
      REMARK: '',
    },
    {
      ID: '2',
      OPER_CODE: 'Test1',
      OPER_NAME: '测试一',
      OPER_TYPE: '1',
      FACTORY: '鸿鹄WMS',
      IS_FPY: 'Y',
      IS_REFLOW: 'Y',
      CREATE_USER: useUserStore().getUserInfo.userId,
      UPDATE_USER: useUserStore().getUserInfo.userId,
      UPDATE_TIME: '2023-02-06',
      CREATE_TIME: '2023-02-06',
      OPER_ACTION: '2',
      REMARK: '',
    },
    {
      ID: '3',
      OPER_CODE: 'Test2',
      OPER_NAME: '测试二',
      OPER_TYPE: '1',
      FACTORY: '鸿鹄WMS',
      IS_FPY: 'Y',
      IS_REFLOW: 'Y',
      CREATE_USER: useUserStore().getUserInfo.userId,
      UPDATE_USER: useUserStore().getUserInfo.userId,
      UPDATE_TIME: '2023-02-06',
      CREATE_TIME: '2023-02-06',
      OPER_ACTION: '4',
      REMARK: '',
    },
    {
      ID: '4',
      OPER_CODE: 'Test3',
      OPER_NAME: '测试三',
      OPER_TYPE: '1',
      FACTORY: '鸿鹄WMS',
      IS_FPY: 'Y',
      IS_REFLOW: 'Y',
      CREATE_USER: useUserStore().getUserInfo.userId,
      UPDATE_USER: useUserStore().getUserInfo.userId,
      UPDATE_TIME: '2023-02-06',
      CREATE_TIME: '2023-02-06',
      OPER_ACTION: '4',
      REMARK: '',
    },
    {
      ID: '5',
      OPER_CODE: 'PACKING',
      OPER_NAME: '包装',
      OPER_TYPE: '1',
      FACTORY: '鸿鹄WMS',
      IS_FPY: 'N',
      IS_REFLOW: 'N',
      CREATE_USER: useUserStore().getUserInfo.userId,
      UPDATE_USER: useUserStore().getUserInfo.userId,
      UPDATE_TIME: '2023-02-06',
      CREATE_TIME: '2023-02-06',
      OPER_ACTION: '4',
      REMARK: '',
    },
  ];
  const model: OperPageListGetResultModel = {
    // items: data.Data.data,
    // total: data.Data.totals,
    items: data,
    total: data.length,
  };
  return model;
}

/*
 * 获取所有工序列表
 */
export const getOperAllList = async () => {
  const sqlcmd = '';
  const rParams = genAction('MES_OPERATION', sqlcmd);
  return getOperAllListAsync(rParams);
};
async function getOperAllListAsync(_params: ApiAction<string>) {
  // const data = await defHttp.post<ApiAction<OperListItem[]>>(
  //   { url: Api.EntityPageList, params },
  //   {
  //     isTransformResponse: false,
  //   },
  // );
  // const model: OperPageListGetResultModel = {
  //   // items: data.Data.data,
  //   // total: data.Data.totals,
  //   items: data.Data,
  //   total: data.Data.length,
  // };
  const data: OperListItem[] = [
    {
      ID: '1',
      OPER_CODE: 'ASSY',
      OPER_NAME: '组装上料',
      OPER_TYPE: '1',
      FACTORY: '鸿鹄WMS',
      IS_FPY: 'N',
      IS_REFLOW: 'N',
      CREATE_USER: useUserStore().getUserInfo.userId,
      UPDATE_USER: useUserStore().getUserInfo.userId,
      UPDATE_TIME: '2023-02-06',
      CREATE_TIME: '2023-02-06',
      OPER_ACTION: '1',
      REMARK: '',
    },
    {
      ID: '2',
      OPER_CODE: 'Test1',
      OPER_NAME: '测试一',
      OPER_TYPE: '1',
      FACTORY: '鸿鹄WMS',
      IS_FPY: 'Y',
      IS_REFLOW: 'Y',
      CREATE_USER: useUserStore().getUserInfo.userId,
      UPDATE_USER: useUserStore().getUserInfo.userId,
      UPDATE_TIME: '2023-02-06',
      CREATE_TIME: '2023-02-06',
      OPER_ACTION: '2',
      REMARK: '',
    },
    {
      ID: '3',
      OPER_CODE: 'Test2',
      OPER_NAME: '测试二',
      OPER_TYPE: '1',
      FACTORY: '鸿鹄WMS',
      IS_FPY: 'Y',
      IS_REFLOW: 'Y',
      CREATE_USER: useUserStore().getUserInfo.userId,
      UPDATE_USER: useUserStore().getUserInfo.userId,
      UPDATE_TIME: '2023-02-06',
      CREATE_TIME: '2023-02-06',
      OPER_ACTION: '4',
      REMARK: '',
    },
    {
      ID: '4',
      OPER_CODE: 'Test3',
      OPER_NAME: '测试三',
      OPER_TYPE: '1',
      FACTORY: '鸿鹄WMS',
      IS_FPY: 'Y',
      IS_REFLOW: 'Y',
      CREATE_USER: useUserStore().getUserInfo.userId,
      UPDATE_USER: useUserStore().getUserInfo.userId,
      UPDATE_TIME: '2023-02-06',
      CREATE_TIME: '2023-02-06',
      OPER_ACTION: '4',
      REMARK: '',
    },
    {
      ID: '5',
      OPER_CODE: 'PACKING',
      OPER_NAME: '包装',
      OPER_TYPE: '1',
      FACTORY: '鸿鹄WMS',
      IS_FPY: 'N',
      IS_REFLOW: 'N',
      CREATE_USER: useUserStore().getUserInfo.userId,
      UPDATE_USER: useUserStore().getUserInfo.userId,
      UPDATE_TIME: '2023-02-06',
      CREATE_TIME: '2023-02-06',
      OPER_ACTION: '4',
      REMARK: '',
    },
  ];
  const model: OperPageListGetResultModel = {
    items: data,
    total: data.length,
  };
  return model;
}

//保存
export const SaveOper = async (params: OperListItem, isUpdate: boolean) => {
  let data;
  if (isUpdate) {
    data = await defHttp.post(
      { url: Api.UpdateEntity, params: genAction('MES_OPERATION', params) },
      {
        errorMessageMode: 'none',
        isTransformResponse: false,
      },
    );
  } else {
    params.ID = buildUUID(); //生成GUID
    params.CREATE_USER = useUserStore().getUserInfo.userId;
    data = await defHttp.post(
      { url: Api.AddEntity, params: genAction('MES_OPERATION', params) },
      {
        errorMessageMode: 'none',
        isTransformResponse: false,
      },
    );
  }
  return data;
};
//删除
export const DeleteOper = async (params: Recordable) => {
  const usParams = genAction('MES_OPERATION', [params]);
  return await defHttp.post(
    { url: Api.DeleteList, params: usParams },
    {
      errorMessageMode: 'none',
      isTransformResponse: false,
    },
  );
};
